Robot Simulator of the Robotics Group for Self-Organization of Control: PlotOptionEngine Class Reference

# PlotOptionEngine Class Reference

`#include <plotoptionengine.h>`

Collaboration diagram for PlotOptionEngine:
[legend]

List of all members.

## Public Member Functions
| PlotOptionEngine (const PlotOption &plotOption)
| PlotOptionEngine (const std::list< PlotOption > &plotOptions)
virtual | ~PlotOptionEngine ()
virtual bool | init (AbstractController *maybe_controller=0)
| initializes PlotOptionEngine and opens all pipes and stuff.
virtual bool | reInit ()
| Reinitialises the PlotOptionEngine.
virtual void | closePipes ()
| Closes all open pipes of the current used PlotOptions.
virtual void | setName (const std::string &name)
| sets the name of all plotoptions (call before init, but after options are added)
virtual PlotOption & | addPlotOption (PlotOption &plotoption)
| adds the PlotOptions to the list of plotoptions If a plotoption with the same Mode exists, then the old one is deleted first
virtual bool | addAndInitPlotOption (PlotOption &plotoption, bool forceInit=false)
| Adds the PlotOptions to the list of plotoptions If a plotoption with the same Mode exists, then the old one is deleted first The plotting is also initialized but only if the PlotOptionEngine is already intialized, This can be forced by additional param.
virtual bool | removePlotOption (PlotMode mode)
| removes the PlotOptions with the given type
virtual void | addInspectable (const Inspectable *inspectable, bool front=false)
| adds an inspectable object for logging.
virtual void | addConfigurable (const Configurable *c)
| adds an configureable object for logging.
virtual void | writePlotComment (const char *cmt)
| write comment to output streams (PlotOptions).
virtual void | plot (double time)
## Protected Member Functions
bool | initPlotOption (PlotOption &po)
## Protected Attributes
std::list< PlotOption > | plotOptions
std::list< const Inspectable * > | inspectables
std::list< const Configurable * > | configureables
long int | t
bool | initialised
AbstractController * | maybe_controller
std::string | name

## Constructor & Destructor Documentation

PlotOptionEngine | ( | const PlotOption & | plotOption | ) |

PlotOptionEngine | ( | const std::list< PlotOption > & | plotOptions | ) |

~PlotOptionEngine | ( |  | ) | `[virtual]`

## Member Function Documentation

bool addAndInitPlotOption | ( | PlotOption & | plotoption,
|  | bool | forceInit = `false` |
| ) |  |  | `[virtual]`

Adds the PlotOptions to the list of plotoptions If a plotoption with the same Mode exists, then the old one is deleted first The plotting is also initialized but only if the PlotOptionEngine is already intialized, This can be forced by additional param.

Parameters:

  | plotoption | The PlotOption to add
  | forceInit | force initialization of PlotOption even if PlotOptionEngine is not initalized. This may cause problems. Use this at your own risk.

Returns:

void addConfigurable | ( | const Configurable * | c | ) | `[virtual]`

adds an configureable object for logging.

Must be called before init!

void addInspectable | ( | const Inspectable * | inspectable,
|  | bool | front = `false` |
| ) |  |  | `[virtual]`

adds an inspectable object for logging.

Must be called before init!

PlotOption & addPlotOption | ( | PlotOption & | plotoption | ) | `[virtual]`

adds the PlotOptions to the list of plotoptions If a plotoption with the same Mode exists, then the old one is deleted first

void closePipes | ( |  | ) | `[virtual]`

Closes all open pipes of the current used PlotOptions.

bool init | ( | AbstractController * | maybe_controller = `0` | ) | `[virtual]`

initializes PlotOptionEngine and opens all pipes and stuff.

The optional controller is used to print structure information

bool initPlotOption | ( | PlotOption & | po | ) | `[protected]`

void plot | ( | double | time | ) | `[virtual]`

bool reInit | ( |  | ) | `[virtual]`

Reinitialises the PlotOptionEngine.

This means it closes all open pipes by calling closePipes() and restarts them by calling init().

Returns:
  true if succeeded, otherwise false.

bool removePlotOption | ( | PlotMode | mode | ) | `[virtual]`

removes the PlotOptions with the given type

Returns:
  true if sucessful, false otherwise

virtual void setName | ( | const std::string & | name | ) | `[virtual]`

sets the name of all plotoptions (call before init, but after options are added)

void writePlotComment | ( | const char * | cmt | ) | `[virtual]`

write comment to output streams (PlotOptions).

For instance changes in parameters.

## Member Data Documentation

std::list< const Configurable* > configureables`[protected]`

bool initialised`[protected]`

std::list<const Inspectable* > inspectables`[protected]`

AbstractController* maybe_controller`[protected]`

std::string name`[protected]`

std::list<PlotOption> plotOptions`[protected]`

long int t`[protected]`

The documentation for this class was generated from the following files:

- plotoptionengine.h
- plotoptionengine.cpp